#pragma semicolon 1

#include <sourcemod>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Endurance]",
	author	= "GoDtm666?",
	version = "1.0.2"
};

#define ITEM_NAME "endurance"
new bool:g_bAccess[MAXPLAYERS + 1];

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE)) SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	LoadTranslations("vip_modules_description.phrases");
	HookEvent("player_hurt", player_hurt, EventHookMode_Post);
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public bool:VIP_Description(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], String:description[], description_size)
{
	FormatEx(description, description_size, "%T", ITEM_NAME, client);
	return true;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) return VGA_AlreadyEnabled;
	SetStatus(client, true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	SetStatus(client, false);
}

stock SetStatus(client, bool:enabled)
{
	g_bAccess[client] = enabled;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////

public player_hurt(Handle:event, const String:name[], bool:silent)
{
	decl client;
	if (g_bAccess[(client = GetClientOfUserId(GetEventInt(event, "userid")))])
		SetEntPropFloat(client, Prop_Send, "m_flVelocityModifier", 1.0);
}

public OnClientDisconnect_Post(client)
	g_bAccess[client] = false;